<?php


// Contemplate Reporter (reporter/reporter.php) version 2.0.1
// Copyright 2003-2011 Arlo Leach (http://www.arlomedia.com)
// This product includes software developed by Type A Learning Agency (http://www.typea.net)
// This file may be used, modified, or redistributed under the terms
// of the open-source agreement contained in docs/license.txt


// get configuration settings

	include "../config/constants.php";
	

// check for a password before continuing

	if (PASSWORD) {
		session_start();
		
		// log in if requested
		if (isset($_POST["password"])) {
			$_SESSION["password"] = $_POST["password"];
		}
		
		// log out if requested
		if (get_query_argument("logout", "bool")) {
			unset($_SESSION["password"]);
		}
		
		// check the login status
		$show_login = ((!isset($_SESSION["password"]))||($_SESSION["password"] != PASSWORD));
	}
	

// define some additional internal constants that users wouldn't need to modify

	define("BLANK_MARKER", "--");
	define("GRAPH_WIDTH", 140);
	define("PRE_VISITOR_DATA_FLAG", "(visitors not tracked)");
	define("MY_HOST", (isset($_SERVER["HTTP_HOST"])) ? $_SERVER["HTTP_HOST"] : "");
	define("MY_DOMAIN", (preg_match("/www\./", MY_HOST)) ? substr(MY_HOST, 3, strlen(MY_HOST)) : MY_HOST);


// do some cleanup on the settings

	$graph_color = str_replace("#", "", GRAPH_COLOR); // Flash doesn't use # to denote a hex value; this ought to be done inside Flash, then
	$graph_image = (GRAPH_IMAGE) ? "../".GRAPH_IMAGE : "" ; // make the path relative to the Flash file, which is in a subdirectory of the Contemplate directory; this could also be done inside Flash so we can just use the constant directly
	//$graph_image = str_replace("../../", "%252E%252E%252F%252E%252E%252F", $graph_image); // double-encode the up delimiter to prevent Mac IE from decoding and then rewriting it
	

// look for runtime commands that might change our output

	$all = get_query_argument("all", "bool");
	$month = get_query_argument("month", "filename");
	$section = get_query_argument("section", "filename");
	//$clear = get_query_argument("clear", "bool");
	$inspector_key = get_query_argument("inspector_key", "filename");
	$inspector_value = get_query_argument("inspector_value", "text");
	$back_label = get_query_argument("back_label", "text");
	$realtime = get_query_argument("realtime", "bool");


// connect to the database and make sure it has some data

	@$database_connection = mysql_connect(REPORTER_DATABASE_ADDRESS, REPORTER_DATABASE_USERNAME, REPORTER_DATABASE_PASSWORD);
	if (!$database_connection) {
		exit("Could not connect to database at ".REPORTER_DATABASE_ADDRESS);
	}
	
	@$database_selected = mysql_select_db(REPORTER_DATABASE_NAME);
	if (!$database_selected) {
		exit("Could not select database ".REPORTER_DATABASE_NAME);
	}
	
	$query = "SELECT timestamp FROM `".REPORTER_DATABASE_TABLE."` LIMIT 1";
	$result = mysql_query($query);
	$count = mysql_num_rows($result);
	if (!$count) {
		exit("Database ".REPORTER_DATABASE_TABLE." has no data; please enable the LOG_SITE_TRAFFIC setting in constants.php and view your website to generate some data");
	}
	

// make a filter based on the exclude hosts value

	if (EXCLUDE_TRAFFIC_FROM_HOSTS) {
		$exclude_hosts = EXCLUDE_TRAFFIC_FROM_HOSTS;
		$exclude_hosts = str_replace(" ", "", $exclude_hosts);
		$exclude_hosts = explode(",", $exclude_hosts);
		$exclude_hosts_filter = array();
		foreach($exclude_hosts as $host) {
			$exclude_hosts_filter[] = "host NOT LIKE '%$host%'";
		}
		$exclude_hosts_filter = "(".implode(" AND ", $exclude_hosts_filter).")";
	} else {
		$exclude_hosts_filter = "1";
	}


// make a filter based on the show errors value

	if (INCLUDE_ERROR_PAGES_IN_TOTALS) {
		$exclude_errors_filter = "1";
	} else {
		$exclude_errors_filter = "http_status=200 AND assembler_error=''";
	}
	
	
// define our internal functions

	function get_query_argument($name, $type, $default="") {
		// return the value from the $_GET array, or an empty string if the argument doesn't exist
		
		// we'll forbid users from creating arguments that might interfere with data we get through the query string
		GLOBAL $reserved_argument_names;
		$reserved_argument_names[] = $name;
		
		if (isset($_GET[$name])) {
			$value = $_GET[$name];
		} else if ($default) {
			$value = $default;
		} else {
			switch ($type) {
				case "bool": $value = false; break;
				case "name": $value = ""; break;
				case "filename": $value = ""; break;
				case "text": $value = ""; break;
			}
		}
		$value = sanitize($value, $type);

		return $value;
	}
	
	function sanitize($value, $type) {
		// remove any unnecessary characters that could be used for an exploit
		switch ($type) {
			case "bool": settype($value, "bool"); break;
			case "name": $value = preg_replace("/\W/", "", $value); break;
			case "filename": $value = preg_replace("/[^\w-\.,\/\?\&\=\% \+]/", "", $value); break;
			case "text": break;
		}
		return $value;
	}

	function build_section_table($section, $month, $all_requested) {
		// this is in a function because we usually have to display more than one of these tables on the same page
		GLOBAL $sections_interface, $sections_database, $exclude_hosts_filter, $exclude_errors_filter, $country_codes;
		$output = "";
		
		$all = ($section == $all_requested);
		if (($all_requested)&&(!$all)) { return ""; }
		
		// table heading
		$output .= "<table cellpadding=\"2\" cellspacing=\"0\" border=\"0\">\n\n";
		if (!$all) {
			$label = "Top ".TOP_N." ".$sections_interface[$section];
			$button_link = (ONE_BIG_PAGE) ? "#$section" : "reporter.php?month=$month&section=$section" ;
			$button = "<a href=\"$button_link\">All ".$sections_interface[$section]."</a>";
		} else {
			$label = "<a name=\"$section\">All ".$sections_interface[$section]."</a>";
			$button = (ONE_BIG_PAGE) ? "<a href=\"#top\">Top</a>" : "" ;
		}
		$output .= "<tr><th colspan=\"6\" class=\"subheading\">$label</td></tr>\n\n";
	
		// debug
		/*
		$query = "
			SELECT visitor_id, page
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE timestamp>='$month-01 00:00:00'
			AND timestamp<='$month-31 23:59:59'
			AND entry=1
			AND $exclude_hosts_filter
			AND $exclude_errors_filter
			AND page='error_404'
			ORDER BY timestamp
		";
		$result = mysql_query($query);
		print mysql_error();
		$foo = 1;
		while ($row = mysql_fetch_assoc($result)) {
			extract($row);
			print "$foo: found entry for $page for $visitor_id<br>";
			$foo++;
		}
		*/

		// run a query for the specified section
		$limit = ($all) ? "" : "LIMIT ".TOP_N ;
		switch ($section) {
			case "dates":
				$select = "SELECT SUBSTRING(timestamp, 1, 10) AS item, COUNT(timestamp) AS count";
				if ($all) { $order = "item ASC"; }
				break;

			case "referrers":
				$select = "SELECT IF(referrer NOT LIKE '%".MY_DOMAIN."%', referrer, '') AS item, COUNT(timestamp) AS count";
				break;

			case "countries":
				// the if find_in_set groups unknown hosts into one item (we could probably also just check for numeric values, which would be simpler and would give the same result in most cases)
				$country_list = implode(",", array_keys($country_codes));
				$select = "SELECT IF(
					FIND_IN_SET(REVERSE(SUBSTRING(REVERSE(host), 1, LOCATE('.', REVERSE(host)) - 1)), '$country_list'),
					REVERSE(SUBSTRING(REVERSE(host), 1, LOCATE('.', REVERSE(host)) - 1)),
					'')
				AS item, COUNT(timestamp) AS count";
				break;

			case "visitors":
				$select = "SELECT visitor_id AS item, COUNT(visitor_id) AS count, user_agent";
				break;

			case "entry_pages":
				$select = "SELECT page AS item, COUNT(page) AS count";
				$where = "AND entry=1";
				break;

			case "exit_pages":
				$select = "SELECT page AS item, COUNT(page) AS count";
				$where = "AND `exit`=1";
				break;

			case "errors_http":
				$select = "SELECT http_status AS item, COUNT(http_status) AS count";
				$where = "AND http_status!=200";
				$exclude_errors_filter = "1"; // override this to show the errors here
				break;

			case "errors_assembler":
				$select = "SELECT assembler_error AS item, COUNT(assembler_error) AS count";
				$where = "AND assembler_error!=''";
				$exclude_errors_filter = "1"; // override this to show the errors here
				break;

			default:
				$column = $sections_database[$section];
				$select = "SELECT $column AS item, COUNT($column) AS count";
		}
		if (!isset($where)) { $where = ""; }
		if (!isset($order)) { $order = "count DESC"; }
		$query = "
			$select
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE timestamp>='$month-01 00:00:00'
			AND timestamp<='$month-31 23:59:59'
			$where
			AND $exclude_hosts_filter
			AND $exclude_errors_filter
			GROUP BY item
			ORDER BY $order
			$limit
		";
		$result = mysql_query($query);

		// display the table rows with the result data
		while ($row = mysql_fetch_row($result)) {
			list($item, $count) = $row;
			
			if (!isset($page_views_greatest)) {
				if (($section == "dates")&&($all)) {
					// we're showing the all dates table in date order, so we have to first look up the largest date value
					// we can do that by tweaking the original query and running it again
					$query_greatest = $query;
					$query_greatest = str_replace($order, "count DESC", $query_greatest);
					$query_greatest = $query_greatest." LIMIT 1";
					$result_greatest = mysql_query($query_greatest);
					$row_greatest = mysql_fetch_assoc($result_greatest);
					$page_views_greatest = $row_greatest["count"];
				} else {
					// otherwise we're showing the items in reverse count order, so we can just use the first count value
					$page_views_greatest = $count;
				}
			}

			if (!$item) { $item = BLANK_MARKER; }
			
			$inspector_key = $section;
			$inspector_value = $item;

			// separate the original value from the display value for the inspect script
			if ($section == "visitors") {
				if (strpos($inspector_value, ") ") !== false) {
					$key = substr($inspector_value, 0, strpos($inspector_value, ") ") + 1);
					$inspector_value = substr($inspector_value, strpos($inspector_value, ") ") + 2);
				}
			}
			
			// limit the item display length to a predetermined number of characters
			$item_complete = $item;
			$item = (strlen($item) > MAXIMUM_LABEL_LENGTH) ? substr($item, 0, MAXIMUM_LABEL_LENGTH)."..." : $item ;
			
			// format the display of some items
			if (($section == "pages")||($section == "entry_pages")||($section == "exit_pages")) {
				$item = page_display($item_complete, $item);
			}
			if ($section == "referrers") {
				$item = referrer_display($item_complete, $item);
			}
			if ($section == "visitors") {
				$user_agent = $row[2];
				$item = visitor_display($item_complete, $user_agent);
			}
			if ($section == "countries") {
				$item = country_display($item_complete);
			}
			if ($section == "ip_addresses") {
				$item = ip_address_display($item_complete);
			}
			if ($section == "errors_http") {
				$item = http_error_display($item_complete);
			}
						
			// provide a link for seeing all the fields for a particular item
			$back_label = ($section) ? "All ".$sections_interface[$section] : "Top ".$TOP_N."%27s" ;
			$inspector_link = ($item != BLANK_MARKER) ? "<a href=\"reporter.php?month=$month&inspector_key=$inspector_key&inspector_value=".urlencode($inspector_value)."&back_label=".urlencode($back_label)."\" class=\"inspect\">Inspect</a>" : "&nbsp;" ;					
			
			$output .= "<tr><td class=\"body\">\n";
			$output .= $inspector_link."&nbsp;";
			$output .= "</td>\n<td class=\"body column_spacing\">\n";
			$output .= $item;
			$output .= "</td>\n<td class=\"body column_spacing\">\n";
			$output .= $count;
			$output .= "</td>\n<td width=\"".GRAPH_WIDTH."\">\n";
			$output .= "<div class=\"graph_bar\" style=\"border-color: ".random_color()."; width: ".(($count / $page_views_greatest) * GRAPH_WIDTH)."px;\"></div>\n";
			$output .= "</td></tr>\n\n";
		
		}
		
		// bottom of table
		$output .= "</table>\n\n";
		
		// more/top buttons after table
		if ($button) {
			$space_after = (ONE_BIG_PAGE) ? 36 : 18 ;
			$output .= "<p class=\"body\" style=\"margin-bottom: {$space_after}px;\">$button</p>\n\n";
		}
		
		return $output;
	}
			
	function random_color() {
		// returns a random web-safe color definition
		$colors = Array("00","33","66","99","CC","FF");
		$r = $colors[rand(0,4)]; // rand(5) instead of rand(6) keeps them from getting too light to read
		$g = $colors[rand(0,4)];
		$b = $colors[rand(0,4)];
		$color = "#".$r.$g.$b;
		return $color;		
	}
	
	function month_display($month) {
		// convert 2003-05 or 2003-05-07 06:00:00 to May 2003
		GLOBAL $months;
		$month_year = explode("-", $month);
		$month_display = $months[intval($month_year[1]) - 1];
		$year_display = $month_year[0];
		return "$month_display $year_display";
	}
	
	function page_display($page, $page_truncated="") {
		if (!$page_truncated) { $page_truncated = $page; }
		if ((trim($page))&&($page != BLANK_MARKER)) {
			$page = "<a href=\"../assembler.php?page=$page\" target=\"_new\">$page_truncated</a>";
		}
		return $page;
	}
	
	function referrer_display($referrer, $referrer_truncated="") {
		if (!$referrer_truncated) { $referrer_truncated = $referrer; }
		if ((trim($referrer))&&($referrer != BLANK_MARKER)) {
			$referrer = "<a href=\"$referrer\" target=\"_new\">$referrer_truncated</a>";
		}
		return $referrer;
	}
	
	function ip_address_display($ip_address) {
		if ((trim($ip_address))&&($ip_address != BLANK_MARKER)) {
			$ip_address = "<a href=\"http://ws.arin.net/cgi-bin/whois.pl?queryinput=$ip_address\" target=\"_new\">$ip_address</a>";
		}
		return $ip_address;
	}
	
	function visitor_display($visitor_id, $user_agent) {
		// display as a user agent and timestamp if the timestamp is present
		if (preg_match("/\w+-(\d\d\d\d)(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/", $visitor_id, $matches)) {
			$visitor = $matches[1]."-".$matches[2]."-".$matches[3]." ".$matches[4].":".$matches[5].":".$matches[6];
			$user_agent_display = $user_agent;
			if (preg_match("/.+\)(.+)/", $user_agent_display, $matches)) {
				$user_agent_display = $matches[1]; // if there is a parenthesis, just take the text after the parenthesis
			}
			$user_agent_display = str_replace("compatible; ", "", $user_agent_display);
			$user_agent_display = (strlen($user_agent_display) > (MAXIMUM_LABEL_LENGTH - 22)) ? substr($user_agent_display, 0, MAXIMUM_LABEL_LENGTH - 25)."..." : $user_agent_display ;
			$visitor = $user_agent_display." (".$visitor.")";
		} else {
			$visitor = "";
		}
		return $visitor;
	}
	
	function country_display($host) {
		// get the country code from complete hostname or TLD
		GLOBAL $country_codes;
		if (strpos($host, ".") === false) {
			$TLD = $host;
		} else if (preg_match("/\.([^\.\d]+)$/", $host, $matches)) {
			$TLD = strtolower($matches[1]);
		} else {
			$TLD = "";
		}
		if (($TLD)&&(isset($country_codes[$TLD]))) {
			$country = $country_codes[$TLD];
		} else {
			$country = BLANK_MARKER;
		}
		return $country;
	}

	function http_error_display($code) {
		// get the error description
		GLOBAL $http_error_codes;
		if (($code)&&(isset($http_error_codes[$code]))) {
			$error = $code.": ".$http_error_codes[$code];
		} else {
			$error = "$code: Unknown error";
		}
		return $error;
	}
	
		
// define some relational values for easy access

	$sections_interface = Array(
		"dates"=>"dates",
		"pages"=>"pages",
		"referrers"=>"referrers",
		"entry_pages"=>"entry pages",
		"exit_pages"=>"exit pages",
		"visitors"=>"visitors",
		"hosts"=>"hosts",
		"countries"=>"countries",
		"ip_addresses"=>"IP addresses",
		"user_agents"=>"user agents",
		"errors_http"=>"HTTP errors",
		"errors_assembler"=>"assembler errors"
	);
	$sections_interface_singular = Array(
		"dates"=>"date",
		"pages"=>"page",
		"referrers"=>"referrer",
		"entry_pages"=>"entry page",
		"exit_pages"=>"exit page",
		"visitors"=>"visitor",
		"hosts"=>"host",
		"countries"=>"country",
		"ip_addresses"=>"IP address",
		"user_agents"=>"user agent",
		"errors_http"=>"HTTP error",
		"errors_assembler"=>"assembler error"
	);
	$sections_database = Array(
		"dates"=>"timestamp",
		"pages"=>"page",
		"referrers"=>"referrer",
		"entry_pages"=>"",
		"exit_pages"=>"",
		"visitors"=>"visitor_id",
		"hosts"=>"host",
		"countries"=>"",
		"ip_addresses"=>"ip_address",
		"user_agents"=>"user_agent",
		"errors_http"=>"",
		"errors_assembler"=>"error"
	);
	
	$months = Array("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

	$http_error_codes = Array(
		"201" => "Created",
		"202" => "Accepted",
		"203" => "Non-Authoritative Information",
		"204" => "No Content",
		"205" => "Reset Content",
		"206" => "Partial Content",
		"400" => "Bad Request",
		"401" => "Not authorized",
		"402" => "Payment Required",
		"403" => "Forbidden",
		"404" => "Not Found",
		"405" => "Method Not Allowed",
		"406" => "Not Acceptable",
		"407" => "Proxy Authentication Required",
		"408" => "Request Timeout",
		"409" => "Conflict",
		"410" => "Gone",
		"411" => "Length Required",
		"412" => "Precondition Failed",
		"413" => "Request Entity Too Large",
		"414" => "Request-URI Too Long",
		"415" => "Unsupported Media Type",
		"416" => "Requested Range Not Satisfiable",
		"417" => "Expectation Failed",
		"500" => "Internal Server Error",
		"501" => "Not Implemented",
		"502" => "Bad Gateway",
		"503" => "Service Unavailable",
		"504" => "Gateway Timeout",
		"505" => "HTTP Version Not Supported"
	);

	$country_codes = Array(
		"com" => "US Commercial",
		"edu" => "US Educational",
		"org" => "US Organization",
		"net" => "US Network",
		"gov" => "US Government",
		"mil" => "US Military",
		"ac" => "Ascension Island",
		"ad" => "Andorra",
		"ae" => "United Arab Emirates",
		"af" => "Afghanistan",
		"ag" => "Antigua and Barbuda",
		"ai" => "Anguilla",
		"al" => "Albania",
		"am" => "Armenia",
		"an" => "Netherland Antilles",
		"ao" => "Angola",
		"aq" => "Antarctica",
		"ar" => "Argentina",
		"as" => "American Samoa",
		"at" => "Austria",
		"au" => "Australia",
		"aw" => "Aruba",
		"ax" => "Aland Islands",
		"az" => "Azerbaijan",
		"ba" => "Bosnia and Herzegowina",
		"bb" => "Barbados",
		"bd" => "Bangladesh",
		"be" => "Belgium",
		"bf" => "Burkina Faso",
		"bg" => "Bulgaria",
		"bh" => "Bahrain",
		"bi" => "Burundi",
		"bj" => "Benin",
		"bm" => "Bermuda",
		"bn" => "Brunei Darussalam",
		"bo" => "Bolivia",
		"br" => "Brazil",
		"bs" => "Bahamas",
		"bt" => "Bhutan",
		"bv" => "Bouvet Island",
		"bw" => "Botswana",
		"by" => "Belarus",
		"bz" => "Belize",
		"ca" => "Canada",
		"cc" => "Cocos (Keeling) Islands",
		"cd" => "Congo",
		"cf" => "Central African Republic",
		"cg" => "Congo",
		"ch" => "Switzerland",
		"ci" => "Cte d'Ivoire",
		"ck" => "Cook Islands",
		"cl" => "Chile",
		"cm" => "Cameroon",
		"cn" => "China",
		"co" => "Columbia",
		"cr" => "Costa Rica",
		"cs" => "Czechoslovakia",
		"cu" => "Cuba",
		"cv" => "Cape Verde",
		"cx" => "Christmas Island",
		"cy" => "Cyprus",
		"cz" => "Czech Republic",
		"de" => "Germany",
		"dj" => "Djibouti",
		"dk" => "Denmark",
		"dm" => "Dominica",
		"do" => "Dominican Republic",
		"dz" => "Algeria",
		"ec" => "Ecuador",
		"ee" => "Estonia",
		"eg" => "Egypt",
		"eh" => "Western Sahara",
		"er" => "Eritrea",
		"es" => "Spain",
		"et" => "Ethiopia",
		"eu" => "European Union",
		"fi" => "Finland",
		"fj" => "Fiji",
		"fk" => "Falkland Islands",
		"fm" => "Micronesia",
		"fo" => "Faroe Islands",
		"fr" => "France",
		"ga" => "Gabon",
		"gb" => "United Kingdom",
		"gd" => "Grenada",
		"ge" => "Georgia",
		"gf" => "French Guiana",
		"gg" => "Guernsey",
		"gh" => "Ghana",
		"gi" => "Gibraltar",
		"gl" => "Greenland",
		"gm" => "Gambia",
		"gn" => "Guinea",
		"gp" => "Guadelope",
		"gq" => "Equatorial Guinea",
		"gr" => "Greece",
		"gs" => "S. Georgia/S. Sandwich Is.",
		"gt" => "Guatemala",
		"gu" => "Guam",
		"gw" => "Guinea-Bissau",
		"gy" => "Guyana",
		"hk" => "Hong Kong",
		"hm" => "Heard and McDonald Islands",
		"hn" => "Honduras",
		"hr" => "Croatia",
		"ht" => "Haiti",
		"hu" => "Hungary",
		"id" => "Indonesia",
		"ie" => "Ireland",
		"il" => "Israel",
		"im" => "Isle of Man",
		"in" => "India",
		"io" => "British Indian Ocean Territory",
		"iq" => "Iraq",
		"ir" => "Iran",
		"is" => "Iceland",
		"it" => "Italy",
		"je" => "Jersey",
		"jm" => "Jamaica",
		"jo" => "Jordan",
		"jp" => "Japan",
		"ke" => "Kenya",
		"kg" => "Kyrgystan",
		"kh" => "Cambodia",
		"ki" => "Kiribati",
		"km" => "Comoros",
		"kn" => "Saint Kitts and Nevis",
		"kp" => "Korea, People's Republic of",
		"kr" => "Korea, Republic of",
		"kw" => "Kuwait",
		"ky" => "Cayman Islands",
		"kz" => "Kazakhstan",
		"la" => "Lao Democratic Republic",
		"lb" => "Lebanon",
		"lc" => "Saint Lucia",
		"li" => "Liechtenstein",
		"lk" => "Sri Lanka",
		"lr" => "Liberia",
		"ls" => "Lethoso",
		"lt" => "Lithuania",
		"lu" => "Luxembourg",
		"lv" => "Latvia",
		"ly" => "Libyan Arab Jamahiriya",
		"ma" => "Morocco",
		"mc" => "Monaco",
		"md" => "Moldova",
		"mg" => "Madagascar",
		"mh" => "Marshall Islands",
		"mk" => "Macedonia",
		"ml" => "Mali",
		"mm" => "Myanmar",
		"mn" => "Mongolia",
		"mo" => "Macau",
		"mp" => "Northern Mariana Islands",
		"mq" => "Martinique",
		"mr" => "Mauritania",
		"ms" => "Montserrat",
		"mt" => "Malta",
		"mu" => "Mauritius",
		"mv" => "Maldives",
		"mw" => "Malawi",
		"mx" => "Mexico",
		"my" => "Malaysia",
		"mz" => "Mozambique",
		"na" => "Namibia",
		"nc" => "New Caledonia",
		"ne" => "Niger",
		"nf" => "Norfolk Island",
		"ng" => "Nigeria",
		"ni" => "Nicaragua",
		"nl" => "The Netherlands",
		"no" => "Norway",
		"np" => "Nepal",
		"nr" => "Nauru",
		"nu" => "Niue",
		"nz" => "New Zealand",
		"om" => "Oman",
		"pa" => "Panama",
		"pe" => "Peru",
		"pf" => "French Polynesia",
		"pg" => "Papua New Guinea",
		"ph" => "Philippines",
		"pk" => "Pakistan",
		"pl" => "Poland",
		"pm" => "St. Pierre and Miquelon",
		"pn" => "Pitcairn",
		"pr" => "Puerto Rico",
		"ps" => "Palestinian Territories",
		"pt" => "Portugal",
		"pw" => "Palau",
		"py" => "Paraguay",
		"qa" => "Qatar",
		"re" => "Reunion",
		"ro" => "Romania",
		"ru" => "Russia",
		"rw" => "Rwanda",
		"sa" => "Saudi Arabia",
		"sb" => "Solomon Islands",
		"sc" => "Seychelles",
		"sd" => "Sudan",
		"se" => "Sweden",
		"sg" => "Singapore",
		"sh" => "Saint Helena",
		"si" => "Slovenia",
		"sj" => "Svalbard/Jan Mayen Islands",
		"sk" => "Slovakia",
		"sl" => "Sierra Leone",
		"sm" => "San Marino",
		"sn" => "Senegal",
		"so" => "Somalia",
		"sr" => "Surinam",
		"st" => "Sao Tome and Principe",
		"sv" => "El Salvador",
		"sy" => "Syrian Arab Republic",
		"sz" => "Swaziland",
		"tc" => "The Turks & Caicos Islands",
		"td" => "Chad",
		"tf" => "French Southern Territories",
		"tg" => "Togo",
		"th" => "Thailand",
		"tj" => "Tajikistan",
		"tk" => "Tokelau",
		"tl" => "Timor-Leste",
		"tm" => "Turkmenistan",
		"tn" => "Tunesia",
		"to" => "Tonga",
		"tp" => "East Timor",
		"tr" => "Turkey",
		"tt" => "Trinidad and Tobago",
		"tv" => "Tuvalu",
		"tw" => "Taiwan",
		"tz" => "Tanzania",
		"ua" => "Ukraine",
		"ug" => "Uganda",
		"uk" => "United Kingdom",
		"um" => "U.S. Minor Outlying Islands",
		"us" => "United States",
		"uy" => "Uruguay",
		"uz" => "Uzbekistan",
		"va" => "Vatican City State",
		"vc" => "Saint Vincent & Grenadines",
		"ve" => "Venezuela",
		"vg" => "British Virgin Islands",
		"vi" => "U.S. Virgin Islands",
		"vn" => "Vietnam",
		"vu" => "Vanuatu",
		"wf" => "Wallis and Futuna Islands",
		"ws" => "Samoa",
		"ye" => "Yemen",
		"yt" => "Mayotte",
		"yu" => "Yugoslavia",
		"za" => "South Africa",
		"zm" => "Zambia",
		"zw" => "Zimbabwe"
	);
	
	$country_codes_reversed = array_flip($country_codes);

	
// if called from the real-time Flash viewer, provide some data for that

	if ($realtime) {
	
		// get the current total page views for this month
		$month = date("Y-m");
		$query = "
			SELECT COUNT(timestamp) AS page_views_total
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE timestamp>='$month-01 00:00:00'
			AND timestamp<='$month-31 23:59:59'
			AND $exclude_hosts_filter
			AND $exclude_errors_filter
		";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		extract($row);

		// grab just the last ten lines to display in the Flash viewer
		// for some reason Flash doesn't display the last one (until another one is generated after that one)
		$tail = array();
		$query = "
			SELECT
				timestamp,
				ip_address,
				host,
				page,
				user_agent,
				referrer
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE $exclude_hosts_filter
			AND $exclude_errors_filter
			ORDER BY timestamp DESC
			LIMIT 10
		";
		$result = mysql_query($query);
		$count = mysql_num_rows($result);
		for ($i=0; $i<$count; $i++) {
			$row = mysql_fetch_row($result);
			$row[] = country_display($row[2]);
			$tail[] = implode("\t", $row);
		}
		$tail = array_reverse($tail);
		$tail = implode("\n", $tail);
		
		// finally, print the results out for the Flash viewer to read
		print "hits=$page_views_total&data_file=".REPORTER_DATABASE_TABLE."&tail=".urlencode($tail);	
		
		exit;
	
	}


// set up the HTML page

	print "
	
		<html>
	
		<head>
		
			<title>Contemplate(tm) Web Templating System</title>
			
			<link rel=\"stylesheet\" href=\"styles.css\" type=\"text/css\">
			<link rel=\"stylesheet\" href=\"../config/styles_override.css\" type=\"text/css\">

		</head>
		
		<body bgcolor=\"#FFFFFF\">
			
	";
	flush();
	

// show the login form if needed, or the logout button if logged in

	if (PASSWORD) {
		if ($show_login) {
			print "
				<p class=\"subheading\">Please enter your password to view reports</p>
				<form name=\"login\" method=\"post\">
					<input type=\"password\" name=\"password\" size=\"16\" />
					<input type=\"submit\" />
				</form>
			</body></html>\n";
			exit;
		} else {
			print "<p class=\"body\" id=\"logout_link\"><a href=\"reporter.php?logout=1\">Log out</a></p>\n";
		}
	}
	
	
// if an inspect key is provided, focus on a cross-section of the month's report

	if ($inspector_key) {
	
		// get the data for this inspector value and count it
		switch ($inspector_key) {
			case "dates":
				$filter = "SUBSTRING(timestamp, 1, 10)='$inspector_value'";
				break;

			case "referrers":
				if ($inspector_value != BLANK_MARKER) {
					$filter = "referrer='$inspector_value'";
				} else {
					$filter = "(referrer LIKE '%".MY_DOMAIN."%' OR referrer='')";
				}
				break;

			case "countries":
				$filter = "SUBSTRING(host, -".strlen($inspector_value).")='$inspector_value'";
				break;

			case "entry_pages":
				$filter = "page='$inspector_value' AND entry=1";
				break;

			case "exit_pages":
				$filter = "page='$inspector_value' AND `exit`=1";
				break;

			case "errors_http":
				if ($inspector_value != BLANK_MARKER) {
					$filter = "http_status='$inspector_value'";
				} else {
					$filter = "http_status=0";
				}
				$exclude_errors_filter = "1"; // override this to show the errors here
				break;

			case "errors_assembler":
				$filter = "assembler_error='$inspector_value'";
				$exclude_errors_filter = "1"; // override this to show the errors here
				break;

			default:
				$column = $sections_database[$inspector_key];
				$filter = "$column='$inspector_value'";
		}
		$query = "
			SELECT 
				timestamp,
				page,
				referrer,
				visitor_id,
				host,
				ip_address,
				user_agent
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE timestamp>='$month-01 00:00:00'
			AND timestamp<='$month-31 23:59:59'
			AND $filter
			AND $exclude_hosts_filter
			AND $exclude_errors_filter
			ORDER BY timestamp
		";
		$result = mysql_query($query);
		$page_views_total = mysql_num_rows($result);
		
		// display a header for the inspector view
		print "<p class=\"heading\"><a name=\"top\">Traffic for ".month_display($month)."</a></p>\n";
		print "<p class=\"subheading\">Where ".$sections_interface_singular[$inspector_key]." is ".stripslashes($inspector_value)."<br />\n";
		print "Total page views: $page_views_total</p>\n\n";
		print "<p class=\"body\">&lt;&ndash; <a href=\"JavaScript:history.back();\">$back_label</a></p>\n\n";
			
		// start the table to display the data
		print "<table cellpadding=\"2\" cellspacing=\"0\" border=\"0\">\n\n";
		print "<tr bgcolor=\"#CCCCCC\">\n";
		print "<td class=\"subheading\">Dates</td>\n";
		print "<td class=\"subheading\">Pages</td>\n";
		print "<td class=\"subheading\">Referrers</td>\n";
		print "<td class=\"subheading\">Visitors</td>\n";
		print "<td class=\"subheading\">Hosts</td>\n";
		print "<td class=\"subheading\">Countries</td>\n";
		print "<td class=\"subheading\">IP Addresses</td>\n";
		print "<td class=\"subheading\">User Agents</td>\n";
		print "</tr>\n\n";
	
		// display the table rows
		while ($row = mysql_fetch_row($result)) {
			list($timestamp, $page, $referrer, $visitor_id, $host, $ip_address, $user_agent) = $row;
			
			// if we're displaying visitors, draw a dividing line between visits
			if (($inspector_key == "visitors")&&($visitor_id != PRE_VISITOR_DATA_FLAG)) {
				if (isset($last_timestamp)) {
					if (($visitor_id != $last_visitor_id)||(strtotime($timestamp) - strtotime($last_timestamp)) > (MINUTES_UNTIL_VISIT_EXPIRES * 60)) {
						print "<tr valign=\"top\"><td colspan=\"8\"><hr /></td></tr>\n";
					}
				}
				$last_timestamp = $timestamp;
				$last_visitor_id = $visitor_id;
			}

			// if we're displaying entry or exit pages, draw a dividing line from the previous visit, then get all the other pages in this visit
			if ( (($inspector_key == "entry_pages")||($inspector_key == "exit_pages")) && ($visitor_id != PRE_VISITOR_DATA_FLAG) ) {
				if (isset($visit_pages)) {
					print "<tr valign=\"top\"><td colspan=\"8\"><hr /></td></tr>\n";
				}
				$visit_pages = array();
				unset($last_timestamp);
				$comparison_direction = ($inspector_key == "entry_pages") ? ">=" : "<=" ;
				$sort_direction = ($inspector_key == "entry_pages") ? "ASC" : "DESC" ;
				$query_visit = "
					SELECT timestamp, page, referrer
					FROM `".REPORTER_DATABASE_TABLE."`
					WHERE visitor_id='$visitor_id'
					AND timestamp$comparison_direction'$timestamp'
					ORDER BY timestamp $sort_direction
				";
				$result_visit = mysql_query($query_visit);
				while ($row_visit = mysql_fetch_row($result_visit)) {
					$timestamp = $row_visit[0];
					if ((isset($last_timestamp))&&(abs(strtotime($timestamp) - strtotime($last_timestamp)) > (MINUTES_UNTIL_VISIT_EXPIRES * 60))) {
						break;
					}
					$visit_pages[$timestamp] = $row_visit;
					$last_timestamp = $timestamp;
				}
				if ($inspector_key == "exit_pages") {
					asort($visit_pages);
				}
			} else {
				$visit_pages[0] = $row;
			}
	
			// loop through the visit pages, or just show the original page if we're not showing entry or exit page visits
			foreach ($visit_pages as $visit_page) {
				list($timestamp, $page, $referrer) = $visit_page;

				print "<tr valign=\"top\">\n";
	
				// timestamp
				print "<td class=\"body\">\n";
				print "$timestamp\n";
				print "</td>\n";
	
				// page
				$page_display = (strlen($page) > MAXIMUM_LABEL_LENGTH) ? wordwrap($page, MAXIMUM_LABEL_LENGTH, "<br />", 1) : $page ;
				$page_display = page_display($page, $page_display);
				print "<td class=\"body\">\n";
				print "$page_display\n";
				print "</td>\n";
	
				// referrer
				$referrer_display = (strlen($referrer) > (MAXIMUM_LABEL_LENGTH / 2)) ? wordwrap($referrer, (MAXIMUM_LABEL_LENGTH / 2), "<br />", 1) : $referrer ;
				$referrer_display = referrer_display($referrer, $referrer_display);
				print "<td class=\"body\">\n";
				print "$referrer_display\n";
				print "</td>\n";
	
				// visitor id
				$visitor_display = visitor_display($visitor_id, $user_agent);
				print "<td class=\"body\">\n";
				print "$visitor_display\n";
				print "</td>\n";
	
				// host
				print "<td class=\"body\">\n";
				print "$host\n";
				print "</td>\n";
	
				// country
				$country_display = country_display($host);
				print "<td class=\"body\">\n";
				print "$country_display\n";
				print "</td>\n";
	
				// ip address
				$ip_address_display = ip_address_display($ip_address);
				print "<td class=\"body\">\n";
				print "$ip_address_display\n";
				print "</td>\n";
	
				// user agent
				print "<td class=\"body\">\n";
				print "$user_agent\n";
				print "</td>\n";
	
				print "</tr>\n\n";
			}
		}
		
		// end of table
		print "</table><p>\n\n";

		// add a back link under the table, and we're done
		print "<p class=\"body\">&lt;&ndash; <a href=\"JavaScript:history.back();\">$back_label</a></p>\n\n";


// if a month is specified, display that month's report

	} else if ($month) {

		// get some general info for this month
		$query = "
			SELECT COUNT(timestamp) AS page_views_total FROM `".REPORTER_DATABASE_TABLE."`
			WHERE timestamp>='$month-01 00:00:00'
			AND timestamp<='$month-31 23:59:59'
			AND $exclude_hosts_filter
			AND $exclude_errors_filter
		";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		extract($row);

		// display a header for the month view
		print "<p class=\"heading\"><a name=\"top\">Traffic for ".month_display($month)."</a></p>\n\n";
		print "<p class=\"subheading\">Total page views: $page_views_total</p>\n\n";
		print "<p class=\"body\">\n";
		print "<a href=\"reporter.php\">Months</a> &gt; \n";
		if (($section)&&(!ONE_BIG_PAGE)) {
			print "<a href=\"reporter.php?month=$month\">Top ".TOP_N."'s</a> &gt; \n";
		} else {
			print "Top ".TOP_N."'s &gt; \n";
		}
		print "<span class=\"link_color\">All</span> ";
		$menu = array();
		foreach ($sections_interface as $keyword=>$display) {
			if ($section == $keyword) {
				$menu[] = ucfirst($display);
			} else {
				$link = (ONE_BIG_PAGE) ? "#$keyword" : "reporter.php?month=$month&section=$keyword" ;
				$menu[] = "<a href=\"$link\">".ucfirst($display)."</a>";
			}
		}
		$menu = implode(", ", $menu);
		print $menu;
		print "</p>\n\n";
		
		// display the tables for each kind of data
		print build_section_table("dates", $month, $section);
		print build_section_table("pages", $month, $section);
		print build_section_table("referrers", $month, $section);
		print build_section_table("entry_pages", $month, $section);
		print build_section_table("exit_pages", $month, $section);
		print build_section_table("visitors", $month, $section);
		print build_section_table("hosts", $month, $section);
		print build_section_table("countries", $month, $section);
		print build_section_table("ip_addresses", $month, $section);
		print build_section_table("user_agents", $month, $section);
		print build_section_table("errors_http", $month, $section);
		print build_section_table("errors_assembler", $month, $section);
		
		// display them again for the "one big page" option
		if (ONE_BIG_PAGE) {
			print build_section_table("dates", $month, "dates");
			print build_section_table("pages", $month, "pages");
			print build_section_table("referrers", $month, "referrers");
			print build_section_table("entry_pages", $month, "entry_pages");
			print build_section_table("exit_pages", $month, "exit_pages");
			print build_section_table("visitors", $month, "visitors");
			print build_section_table("hosts", $month, "hosts");
			print build_section_table("countries", $month, "countries");
			print build_section_table("ip_addresses", $month, "ip_addresses");
			print build_section_table("user_agents", $month, "user_agents");
			print build_section_table("errors_http", $month, "errors_http");
			print build_section_table("errors_assembler", $month, "errors_assembler");
		}

		// add a back link at the bottom, and we're done
		if (!$section) {
			print "<p class=\"body\">&lt;&ndash; <a href=\"reporter.php\">Months</a></p>\n\n";
		} else {
			print "<p class=\"body\">&lt;&ndash; <a href=\"reporter.php?month=$month\">Top ".TOP_N."'s</a></p>\n\n";
		}


// otherwise, build a menu of all the available data files
	
	} else {
	
		// get some general info for the whole collection
		$query = "SELECT timestamp AS first_page_view FROM `".REPORTER_DATABASE_TABLE."` WHERE $exclude_hosts_filter AND $exclude_errors_filter ORDER BY timestamp LIMIT 1";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		extract($row);
		
		$query = "SELECT timestamp AS last_page_view FROM `".REPORTER_DATABASE_TABLE."` WHERE $exclude_hosts_filter AND $exclude_errors_filter ORDER BY timestamp DESC LIMIT 1";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		extract($row);

		$query = "SELECT COUNT(timestamp) AS page_views_total FROM `".REPORTER_DATABASE_TABLE."` WHERE $exclude_hosts_filter AND $exclude_errors_filter";
		$result = mysql_query($query);
		$row = mysql_fetch_assoc($result);
		extract($row);

		// display a header for the index view
		print "<p class=\"heading\">Traffic by month</p>\n\n";
		print "<p class=\"subheading\">\n";
		print "First page view: $first_page_view<br />\n";
		print "Last page view: $last_page_view<br />\n";
		print "Total page views: $page_views_total";
		print "</p>\n\n";
		print "<p class=\"body\">\n";
		print "<a href=\"JavaScript:window.open('realtime.swf?script_extension=php&graph_color=".$graph_color."&graph_image=".$graph_image."&update_interval=".REAL_TIME_UPDATE_INTERVAL."','realtime','width=550,height=500,location=no,menubar=no,directories=no,toolbar=no,scrollbars=yes,resizable=yes,status=yes')\">Real-time display</a>\n\n";	
		print "</p>\n\n";
		
		// top of table
		print "<table cellpadding=\"4\" cellspacing=\"0\" border=\"0\">\n\n";
		print "<tr bgcolor=\"#CCCCCC\" valign=\"bottom\">\n";
		print "<td class=\"subheading\">Monthly&nbsp;reports</td>\n";
		print "<td colspan=\"2\" class=\"subheading\">Page&nbsp;views</td>\n";
		if (USE_COOKIES_TO_TRACK_VISITORS) {
			print "<td class=\"subheading\">Visits</td>\n";
			print "<td class=\"subheading\">Pages/visit</td>\n";
			print "<td class=\"subheading\">Time/visit</td>\n";
			print "<td class=\"subheading\">Visitors</td>\n";
			print "<td class=\"subheading\">Visits/visitor</td>\n";
			$colspan = 8;
		} else {
			$colspan = 3;
		}
		print "</tr>\n\n";

		// get a list of months and their page views, including page views that don't have a visitor ID (so we match the total shown on the months page)
		$months = array();
		$page_views_greatest = 0;
		$limit = ($all) ? "" : "LIMIT 12" ;
		$query = "
			SELECT SUBSTRING(timestamp, 1, 7) AS month, COUNT(timestamp) AS page_views
			FROM `".REPORTER_DATABASE_TABLE."`
			WHERE $exclude_hosts_filter
			AND $exclude_errors_filter
			GROUP BY SUBSTRING(timestamp, 1, 7)
			ORDER BY month DESC
			$limit
		";
		$result = mysql_query($query);
		$count = mysql_num_rows($result);
		for ($i=0; $i<$count; $i++) {
			// looping through the results here lets us get the max value; it also avoids the need to nest queries as we look up visitor info
			$row = mysql_fetch_assoc($result);
			$months[$row["month"]] = $row["page_views"];
			if ($row["page_views"] > $page_views_greatest) { $page_views_greatest = $row["page_views"]; }
		}
		
		// calculate the values for and display one row for each month
		foreach ($months as $month=>$page_views) {
			print "<tr>\n";
			print "<td class=\"body\"><a href=\"reporter.php?month=".$month."\">".$month."</a></td>\n";
			print "<td class=\"body\" align=\"right\">".$page_views."</td>\n";
			print "<td width=\"".GRAPH_WIDTH."\"><div class=\"graph_bar\" style=\"border-color: ".random_color()."; width: ".(($page_views / $page_views_greatest) * GRAPH_WIDTH)."px;\"></div></td>\n";
			if (USE_COOKIES_TO_TRACK_VISITORS) {
				// make sure we have visitor data for this entire month
				$query = "SELECT visitor_id FROM `".REPORTER_DATABASE_TABLE."` WHERE visitor_id='".PRE_VISITOR_DATA_FLAG."' AND SUBSTRING(timestamp, 1, 7)='$month'";
				$result = mysql_query($query);
				$count = mysql_num_rows($result);
				if ($count) {
					print "<td class=\"body\" colspan=\"5\">".PRE_VISITOR_DATA_FLAG."</td>\n";
				} else {
				
					// count the number of page views that have a visitor ID (to calculate pages per visit, since we can't calculate visitor info for page views that don't have a visitor ID
					$query = "
						SELECT COUNT(timestamp) AS page_views_tracked
						FROM `".REPORTER_DATABASE_TABLE."`
						WHERE $exclude_hosts_filter
						AND $exclude_errors_filter
						AND visitor_id!=''
					";
					$result = mysql_query($query);
					$row = mysql_fetch_assoc($result);
					extract($row);
				
					// count the visits (entry pages, signified by entry=1)
					// we could also count page views with `exit`=1 or duration=0, which signifies an exit page
					$query = "
						SELECT COUNT(entry) AS visits
						FROM `".REPORTER_DATABASE_TABLE."`
						WHERE timestamp>='$month-01 00:00:00'
						AND timestamp<='$month-31 23:59:59'
						AND $exclude_hosts_filter
						AND $exclude_errors_filter
						AND visitor_id!=''
						AND entry=1
					";
					$result = mysql_query($query);
					$row = mysql_fetch_assoc($result);
					extract($row);
					
					// count the visitors (unique visitor IDs) and total time (sum of all page durations)
					// we can't know how long the user was on the last page of a visit, so we don't include the duration for those pages; this means our times will be lower than reality, but consistently lower; this seems to be the industry standard way to handle this problem
					$query = "
						SELECT COUNT(DISTINCT visitor_id) AS visitors, SUM(duration) AS time
						FROM `".REPORTER_DATABASE_TABLE."`
						WHERE timestamp>='$month-01 00:00:00'
						AND timestamp<='$month-31 23:59:59'
						AND $exclude_hosts_filter
						AND $exclude_errors_filter
						AND visitor_id!=''
					";
					$result = mysql_query($query);
					$row = mysql_fetch_assoc($result);
					extract($row);
			
					// debug
					/*
					if ($month == "2010-09") {
					$query = "
						SELECT visitor_id, timestamp
						FROM `".REPORTER_DATABASE_TABLE."`
						WHERE timestamp>='$month-01 00:00:00'
						AND timestamp<='$month-31 23:59:59'
						AND entry=1
						AND $exclude_hosts_filter
						AND $exclude_errors_filter
						ORDER BY timestamp
					";
					$result = mysql_query($query);
					$foo = 1;
					while ($row = mysql_fetch_assoc($result)) {
					extract($row);
					print "$foo: logged visit $visitor_id = $timestamp<br>";
					$foo++;
					}
					}
					*/

					// calculate the remaining values from these values
					$pages_per_visit = (round($page_views_tracked / $visits * 100) / 100);
					$time_per_visit = round($time / $visits);
					$visits_per_visitor = (round($visits / $visitors * 100) / 100);
			
					// format the time per visit as minutes and seconds
					if ($time_per_visit > 0) {
						$time_per_visit_minutes = floor($time_per_visit / 60);
						$time_per_visit_seconds = $time_per_visit % 60;
						$time_per_visit_seconds = sprintf("%02d", $time_per_visit_seconds);
						$time_per_visit_display = $time_per_visit_minutes.":".$time_per_visit_seconds;
					} else {
						$time_per_visit_display = "0:00";
					}

					print "<td class=\"body\">".$visits."</td>\n";
					print "<td class=\"body\">".$pages_per_visit."</td>\n";
					print "<td class=\"body\">".$time_per_visit_display."</td>\n";
					print "<td class=\"body\">".$visitors."</td>\n";
					print "<td class=\"body\">".$visits_per_visitor."</td>\n";
					
				}
			}
			print "</tr>\n\n";
		}
		
		// bottom of table
		print "</table>\n\n";
		
		// if we're not already showing all months, and there are more months to show, add a link to show all months
		if ((!$all)&&($first_page_view <= (date("Y") - 1)."-".date("m")."-31 23:59:59")) {
			print "<p class=\"body\"><a href=\"reporter.php?all=1\">All months</a></p>";
		}
	
	}
	

// we're done!

	print "</body></html>\n";

?>